IMPLEMENTATION MODULE Ints;

IMPORT Str;


(*** operations ***)

PROCEDURE Add( VAR z: TValue; x, y: TValue ): BOOLEAN;
BEGIN
  IF (
       ( x > 0 ) &
       ( y > MAX(TValue) - x )
     ) OR (
       ( x < 0 ) &
       ( y < MIN(TValue) - x )
     ) THEN RETURN FALSE END;
  z := x + y;
  RETURN TRUE;
END Add;

PROCEDURE Sub( VAR z: TValue; x, y: TValue ): BOOLEAN;
BEGIN
  IF (
       ( y < 0 ) &
       ( x > MAX(TValue) + y )
     ) OR (
       ( y > 0 ) &
       ( x < MIN(TValue) + y )
     ) THEN RETURN FALSE END;
  z := x - y;
  RETURN TRUE;
END Sub;

PROCEDURE Mul( VAR z: TValue; x, y: TValue ): BOOLEAN;
BEGIN
  IF (
       ( x > 0 ) &
       ( ( y > MAX(TValue) DIV x ) OR ( y < MIN(TValue) DIV x ) )
     ) OR (
       ( x < 0 ) &
       ( ( y < MAX(TValue) DIV x ) OR ( y > MIN(TValue) DIV x ) )
     ) THEN RETURN FALSE END;
  z := x * y;
  RETURN TRUE;
END Mul;

(* truncate towards zero (TopSpeed) *)
PROCEDURE Div( VAR z: TValue; x, y: TValue ): BOOLEAN;
BEGIN
  IF y = 0 THEN RETURN FALSE END;
  z := x DIV y;
  RETURN TRUE;
END Div;

(* truncate towards zero (TopSpeed) *)
PROCEDURE Mod( VAR z: TValue; x, y: TValue ): BOOLEAN;
BEGIN
  IF y = 0 THEN RETURN FALSE END;
  z := x MOD y;
  RETURN TRUE;
END Mod;


(*** conversion ***)

TYPE
  TCnvDesc = RECORD
    CASE : CARDINAL OF
    | 0: li: LONGINT;
    | 1: lc: LONGCARD;
    | 2: c0, c1: CARDINAL;
    END;
  END;

CONST
  maxBase = MAX( CARDINAL );


PROCEDURE Neg( VAR x: TValue );
BEGIN
  x := -x;
END Neg;

PROCEDURE CardToVal( VAR v: TValue; x: CARDINAL );
BEGIN
  v := TValue( x );
END CardToVal;


PROCEDURE Card( c: CHAR ): CARDINAL;
BEGIN
  IF ( c >= '0' ) & ( c <= '9' ) THEN
    RETURN ORD(c) - ORD('0');
  ELSIF ( c >= 'A' ) & ( c <= 'Z' ) THEN
    RETURN ORD(c) - ORD('A') + 10;
  ELSE (* invalid *)
    RETURN maxBase;
  END;
END Card;


(* doesn't work for MIN(LONGINT) *)
(* one more bit needed to fix that (LONGCARD would do) *)
PROCEDURE StrToVal( VAR z: TValue; s-: ARRAY OF CHAR; base: CARDINAL; VAR ok: BOOLEAN );
VAR
  i,l: CARDINAL;
  d: CARDINAL;
  b,x: TValue;
BEGIN
  ok := FALSE;
  IF ( s[0] = 0C ) OR ( base < 2 ) THEN RETURN END;
  CardToVal( b, base );
  IF ( s[0] = '-' ) OR ( s[0] = '+' ) THEN i := 1 ELSE i := 0 END;
  l := HIGH( s );
  z := valZero;
  WHILE ( i <= l ) & ( s[i] # 0C ) DO
    d := Card( s[i] );
    IF d >= base THEN RETURN END;
    CardToVal( x, d );
    IF ~ Mul( z, z, b ) OR ~ Add( z, z, x ) THEN RETURN END;
    INC( i );
  END;
  IF ( s[0] = '-' ) THEN Neg( z ) END;
  ok := TRUE;
END StrToVal;


PROCEDURE Char( v: TValue ): CHAR;
BEGIN
  IF v < 0 THEN
    RETURN '?';
  ELSIF v <= 9 THEN
    RETURN CHR( CARDINAL(v) + ORD('0') );
  ELSIF v <= 36 THEN
    RETURN CHR( CARDINAL(v) - 10 + ORD('A') );
  ELSE
    RETURN '?';
  END;
END Char;


PROCEDURE Revert( VAR s: ARRAY OF CHAR; h: CARDINAL );
VAR
  i: CARDINAL;
  c: CHAR;
BEGIN
  IF h > HIGH(s) THEN h := HIGH( s ) END;
  IF h < 1 THEN RETURN END;
  FOR i := 0 TO ( h - 1 ) DIV 2 DO
    c := s[ i ];
    s[ i ] := s[ h - i ];
    s[ h - i ] := c;
  END;
END Revert;


(* doesn't work for MIN(LONGINT) *)
(* one more bit needed to fix that (LONGCARD would do) *)
PROCEDURE ValToStr( VAR s: ARRAY OF CHAR; v: TValue; base: CARDINAL; VAR ok: BOOLEAN );
VAR
  i,l: CARDINAL;
  b,x: TValue;
  neg: BOOLEAN;
BEGIN
  ok := FALSE;
  CardToVal( b, base );
  neg := v < 0;
  IF neg THEN v := -v END;     (* MIN(LONGINT) = - MIN(LONGINT) *)
  i := 0;
  l := HIGH( s );
  REPEAT
    IF i > l THEN RETURN END;
    IF ~ Mod( x, v, b ) THEN RETURN END;
    s[ i ] := Char( x );
    IF ~ Div( v, v, b ) THEN RETURN END;
    INC( i );
  UNTIL v = 0;
  IF neg THEN
    IF i <= l THEN
      s[ i ] := '-';
      INC( i );
    ELSE
      RETURN
    END;
  END;
  IF i <= l THEN s[ i ] := 0C END;
  Revert( s, i-1 );
  ok := TRUE;
END ValToStr;


END Ints.
